#include <X11/Xlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
int main(void)
{
	Display *d;
	Window w1, w2;
	XEvent e;
	char *msg = "Hello, World!";
	int s;
 
	d = XOpenDisplay(NULL);
	if (d == NULL) {
		fprintf(stderr, "Cannot open display\n");
		exit(1);
	}
 
	s = DefaultScreen(d);
	w1 = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, 100, 100, 1,
	    BlackPixel(d, s), WhitePixel(d, s));
	XSelectInput(d, w1, ExposureMask | KeyPressMask);
	XMapWindow(d, w1);
 
	w2 = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, 100, 100, 1,
	    BlackPixel(d, s), WhitePixel(d, s));
//	XSelectInput(d, w1, ExposureMask | KeyPressMask);
	XMapWindow(d, w2);

	while (1) {
		XNextEvent(d, &e);
		if (e.type == Expose) {
			XFillRectangle(d, w1, DefaultGC(d, s), 20, 20, 10, 10);
			XFillRectangle(d, w2, DefaultGC(d, s), 20, 20, 10, 10);
			XDrawString(d, w1, DefaultGC(d, s), 10, 50, msg,
			    strlen(msg));
			XDrawString(d, w2, DefaultGC(d, s), 10, 50, msg,
			    strlen(msg));
		}
		if (e.type == KeyPress)
			break;
	}
 
	XCloseDisplay(d);
	return 0;
}
